#ifndef __INC_ANIM__
#define __INC_ANIM__


#define	NMI_DOWN		0x01
#define	NMI_V_V			0x02
#define	NMI_SHOT		0x03
#define METEOR			0x04
#define METEOR_D1		0x05
#define METEOR_D2		0x06

#define EXPLOSION		0x0D
#define FONT				0x0E
#define	SELECTOR 		0x0F

#define SHOT				0x10

#define	HERO				0x81
#define	HERO_SHOT1	0x92
#define	HERO_SHOT2	0x93


struct str_Sprite{
	ushort	Idx;
	ushort	X,Y; // upon frame upper left
};

struct str_CBox{
	ushort	X,Y; // upon frame upper left
	ushort	Width;
	ushort	Height;
};

struct str_Frame {
	ushort	nbSprites;
	struct 	str_Sprite	*Sprites;
	ushort	nbCBoxes;
	struct 	str_CBox		*CBoxes;
	ulong		Timer;
	ushort	Next;
	ulong		Data;

//	CHAR	Name[256];
};

struct str_Anim {	
	ushort	Width, Height;
	ushort	nbFrames;
	struct	str_Frame		**Frames;
	ushort 	compressSize;
	uchar 	sprite_width;
	uchar 	sprite_height;
	ushort 	nbTiles;
	uint		*sprite_data;
//	WORD	activeFrame;
};


union sprProp{
		struct {
			char vert; 
			char horiz;			
		}speed; /* for mouvement bhv FULL_LINE, ... */
		struct {
			uchar timer;
			char action;
		}wait; /* for waiting bhv GO_WAIT, ... */
		struct {
			char tileX; 
			char tileY;			
		}dest; /* for mouvement bhv FULL_LINE, ... */
		struct {
			char cos;
			char sin;	
		}shoot; /* for nmi shot */
		
		ushort	defVal;		
};	

#define	MAX_ANIMS	( 40 ) //MAX_SPRITES / 2 )
struct AnimatedSprite 
{
	BOOL  	active;
	uchar 	IDCode;
	uchar		bhvIdx;
	uchar 	curFrame;
	uchar 	curTick;
	ushort	x;
	ushort	y;
	uchar 	palIdx;
	ushort 	idxTile;
	uchar		flip;
	struct 	str_Anim	*AnimLib;
	union 	sprProp		data;
}Anim[MAX_ANIMS];

extern 	struct AnimatedSprite	Anim[MAX_ANIMS];
extern	uchar									Anim_sprNumber;

void	Anim_Init( );
ushort 	Anim_Load( struct str_Anim *AnimLib, ushort idxTile);
uchar	Anim_New( uchar IdCode, struct str_Anim *AnimLib, ushort firstTile, ushort posX, ushort posY, uchar pal, union sprProp data);
void 	Anim_Delete( uchar idxSpr );
void 	Anim_Kill( uchar idxSpr );
void	Anim_Update( );
void	Anim_Update1( );
void	Anim_Update2( );
BOOL	Anim_JumpTo( uchar idxSpr, uchar toFrame);


#endif