#include "genesis.h"
#include "control.h"

#define JOY_REDUNDANCE	( 5 )

struct Joy Joypad1;
struct Joy Joypad2;

/********* PRIVATE ***********/
/* read if joy change or still down */
static void JoyRead1()
{
	ushort joy;
	uchar newBut, newDir, oldBut;
	
	newBut = 0;
	joy = read_joypad1();			

	if (joy)
	{
		newBut = (uchar) (joy&0xF0);
		if (newBut)
		{
				// specific case : RESET
				if (newBut == (BUTTON_A+BUTTON_B+BUTTON_C+BUTTON_S))
				{
     				ResetState = 1;
     				return;
				}
				newBut &= ~Joypad1.keydown;
		}

		Joypad1.key = newBut;	
		Joypad1.keydown= (uchar) (joy&0xF0);

		// specific case : PAUSE
		if (newBut == BUTTON_S)
		{
   		PauseState = !PauseState;
   		return;
		}

		if ( Joypad1.wait )
		{
			Joypad1.wait--;
			return;
		}
		
		newDir = (uchar) (joy&0x0F);
		if (newDir)	Joypad1.key = (newBut|newDir);		

		Joypad1.wait = 0;
		if (joy)	Joypad1.wait = Joypad1.initval;
	}
}

/********* PUBLIC ***********/
/* Init Joy refresh rate */
void Ctrl_Init( uchar redundance )
{
	ushort joy;
	
	init_joypad();	
	
	PauseState = 0;
	ResetState = 0;
		
	Joypad1.key=0x00;
	Joypad1.keydown=0x00;
	Joypad1.wait=0;
	Joypad1.initval=redundance;

	Joypad2.key=0x00;
	Joypad2.keydown=0x00;
	Joypad2.wait=0;
	Joypad2.initval=redundance;	
}

/**/

void Ctrl_Read( )
{
	JoyRead1();
	//JoyRead2();
}
