* m68k calling convention says that, between function calls,
* d0,d1,a0,a1 can be used as scratch registers, however,
* others should be preserved and
* return value -if there is- is placed in d0

#define PORT_VDP_DATA        0xc00000
#define PORT_VDP_CNTL        0xc00004

	.globl	HaltEmu
HaltEmu:
	move.w	#0x9D00, 0xC00004
	rts

	.globl	AlertEmu
AlertEmu:
* %a0 = uchar *string
	movea.l  4(%sp), %a0             | get the first parameter (note that (%sp) is the return address)
	move.w   #0x9e00, %d0
	move.b   (%a0)+, %d0             | write null-termiated string byte by byte to port #0x1e
	beq.s    1f                      | zero length string? no, thanks.
	movea.l  #PORT_VDP_CNTL, %a1

0:	move.w   %d0, (%a1)
	move.b   (%a0)+, %d0
	bne.s    0b

	move.w   %d0, (%a1)              | session ends with a 0 write to port #0x1e
1:	rts

	.globl	StartEmuTimer
StartEmuTimer:
	move.w	#0x9F80, PORT_VDP_CNTL

	rts
	
	.globl	StopEmuTimer
StopEmuTimer:
	move.w	#0x9F40, PORT_VDP_CNTL
	rts
