#include "genesis.h"
#include "level.h"
#include "scroll.h"
#include "anim.h"
#include "fm.h"
#include "script.h"
#include "control.h"

#define	SPEED	2


#define	LEV_INTRO		0xFF
#define	LEV_GOVER		0xFE
#define	LEV_CREDITS	0xFD
#define	LEV_SOM			0


// into "rsc.h"

extern	ushort	title_pal[];
extern	ushort	title_tiles[];

extern	ushort	hero_pal[]; // hero and font2 pal
extern struct str_Anim hero_anim;
extern struct str_Anim selector_anim;
ushort	hero_idx;
extern	ushort	font2[];

extern	ushort	shot_pal[]; // all shots pal
ushort	shot1_idx;
ushort	shot2_idx;
ushort	shot3_idx;

extern	ushort	npc_pal[]; //npc and explosion pal
ushort	npc_idx;
ushort	explo_idx;

extern	ushort	font_pal[]; // intro font pal
extern struct str_Anim font_anim;
ushort	font_idx;

extern	ushort 	level1_width;
extern	ushort 	level1_height;
extern	ushort	level1_fieldB[];
extern	uchar		level1_script[];
extern	ushort	level1_pal[];
extern	ushort	level1_tiles[];

extern	ushort	block_pal[]; // intro font pal
extern struct str_Anim block_anim;
ushort	block_idx;

uchar 	heroSprite;
ushort	heroScore;

static	uchar	nSpeed;
struct 	str_Level	curLevel;

uchar	edition[14]="PDRC#3 EDITION";
uchar start[5]="START";
uchar credit[7]="CREDITS";

uchar gameover[10]="GAME  OVER";

uchar credit1_1[11]="PROGRAMMING";
uchar credit1_2[6]="KANEDA";
uchar credit2_1[3]="ART";
uchar credit2_2[3]="TET";
uchar credit2_3[11]="ARI FELDMAN";
uchar credit3_1[6]="THANKS";
uchar credit3_2[5]="DEEDO";
uchar credit3_3[8]="UCHUUSEN";
uchar credit3_4[6]="FONZIE";
uchar credit3_5[4]="STEF";
uchar credit3_6[3]="CMD";


uchar text1[26] = "PLAYING KANEDA' SHOOTER   ";
uchar text2[26] = "PAUSING KANEDA' SHOOTER   ";





static void Level_TextUpdate( )
{
	ushort tile;
	uchar	*text;
	uchar i;
	
	text = text1;
	if ( PauseState )	text = text2;
	
	tile = 0xA000 - 31;//priority + PAL1
	
	for(i=0; i<26; i++)
	{
		Gen_ShowUnique(  i, 0, tile + text[i], APLAN);
	}
}

static void Level_ScoreUpdate( )
{
	ushort tile, score;
	char i;
	
	tile = 0xE000 +17; //priority + PAL3
	score = heroScore;

	for(i=5; i>=0; i--)
	{
		Gen_ShowUnique(  26+i, 0, tile + (score%10), APLAN);
		score /= 10;
	}
}



/****** LEVEL_INIT ******************
 * init a level
 *************************************/
void Level_Init( uchar levelNum, ushort firstTile )
{
	volatile ushort tileIdx; 
	union sprProp	data;
	ushort tile,score;
	char i;

	data.defVal = 0;
	
	curLevel.idx = levelNum;
	
	switch( levelNum )
	{
		case LEV_INTRO:
			curLevel.width = 32;
			curLevel.height = 32;
			curLevel.pal =  PAL0;
			curLevel.tile_idx = firstTile; 
			curLevel.fieldA = 0; // no field A
			curLevel.fieldB = 0;
			curLevel.script = 0;
				
			font_idx = firstTile;
			Anim_Load( &font_anim, font_idx );
			
			data.defVal = 0; //W
			Anim_New( FONT, &font_anim, font_idx, 128+ 9*8, 128+4*16, PAL0, data);
			data.defVal = 0; //W
			Anim_New( FONT, &font_anim, font_idx, 128+ 9*8, 128+5*16, PAL0, data);
			data.defVal = 0; //W
			Anim_New( FONT, &font_anim, font_idx, 128+ 9*8, 128+6*16, PAL0, data);
			data.defVal = 1; //.
			Anim_New( FONT, &font_anim, font_idx, 128+ 9*8, 128+7*16, PAL0, data);
			data.defVal = 2; //C
			Anim_New( FONT, &font_anim, font_idx, 128+ 10*8, 128+7*16, PAL0, data);
			data.defVal = 3; //O
			Anim_New( FONT, &font_anim, font_idx, 128+ 11*8, 128+7*16, PAL0, data);
			data.defVal = 4; //N
			Anim_New( FONT, &font_anim, font_idx, 128+ 12*8, 128+7*16, PAL0, data);
			data.defVal = 5; //S
			Anim_New( FONT, &font_anim, font_idx, 128+ 13*8+1, 128+7*16, PAL0, data);
			data.defVal = 3; //O
			Anim_New( FONT, &font_anim, font_idx, 128+ 14*8, 128+7*16, PAL0, data);
			data.defVal = 6; //L
			Anim_New( FONT, &font_anim, font_idx, 128+ 15*8, 128+7*16, PAL0, data);
			data.defVal = 7; //E
			Anim_New( FONT, &font_anim, font_idx, 128+ 16*8, 128+7*16, PAL0, data);
			data.defVal = 8; //F
			Anim_New( FONT, &font_anim, font_idx, 128+ 17*8, 128+7*16, PAL0, data);
			data.defVal = 7; //E
			Anim_New( FONT, &font_anim, font_idx, 128+ 18*8, 128+7*16, PAL0, data);
			data.defVal = 9; //v
			Anim_New( FONT, &font_anim, font_idx, 128+ 19*8, 128+7*16, PAL0, data);
			data.defVal = 7; //E
			Anim_New( FONT, &font_anim, font_idx, 128+ 20*8, 128+7*16, PAL0, data);
			data.defVal = 10; //R
			Anim_New( FONT, &font_anim, font_idx, 128+ 21*8, 128+7*16, PAL0, data);
			data.defVal = 1; //.
			Anim_New( FONT, &font_anim, font_idx, 128+ 22*8, 128+7*16, PAL0, data);
			data.defVal = 2; //C
			Anim_New( FONT, &font_anim, font_idx, 128+ 22*8, 128+8*16, PAL0, data);
			data.defVal = 3; //O
			Anim_New( FONT, &font_anim, font_idx, 128+ 22*8, 128+9*16, PAL0, data);
			data.defVal = 11; //M
			Anim_New( FONT, &font_anim, font_idx, 128+ 22*8, 128+10*16, PAL0, data);
			
			
			Gen_SetPal( PAL0, font_pal);
			return;			
			break;
		
		case LEV_SOM: // sommaire
			heroScore = 0; //init the score here
			
			curLevel.width = 32;
			curLevel.height = 32;
			curLevel.pal =  PAL0;
			curLevel.tile_idx = firstTile; 
			curLevel.fieldA = 0; // no field A
			curLevel.fieldB = 0;
			curLevel.script = 0;
			
			unpack(font2, GFX_WRITE_ADDR(firstTile*32), 1007);
			tile = firstTile + 66;
			unpack(title_tiles, GFX_WRITE_ADDR(tile*32), 1081);

			/* O */
			i = 2;
			Gen_ShowUnique(  i+0, 2, tile + 4*6, APLAN);
			Gen_ShowUnique(  i+1, 2, tile + 4*6+1, APLAN);
			Gen_ShowUnique(  i+0, 3, tile + 4*6+2, APLAN);
			Gen_ShowUnique(  i+1, 3, tile + 4*6+3, APLAN);
			Gen_ShowUnique(  i+0, 4, tile + 4*6+4, APLAN);
			Gen_ShowUnique(  i+1, 4, tile + 4*6+5, APLAN);

			/* L */
			i = 5;
			Gen_ShowUnique(  i+0, 2, tile + 1*6, APLAN);
			Gen_ShowUnique(  i+1, 2, tile + 1*6+1, APLAN);
			Gen_ShowUnique(  i+0, 3, tile + 1*6+2, APLAN);
			Gen_ShowUnique(  i+1, 3, tile + 1*6+3, APLAN);
			Gen_ShowUnique(  i+0, 4, tile + 1*6+4, APLAN);
			Gen_ShowUnique(  i+1, 4, tile + 1*6+5, APLAN);

			/* D */
			i = 8;
			Gen_ShowUnique(  i+0, 2, tile + 0*6, APLAN);
			Gen_ShowUnique(  i+1, 2, tile + 0*6+1, APLAN);
			Gen_ShowUnique(  i+0, 3, tile + 0*6+2, APLAN);
			Gen_ShowUnique(  i+1, 3, tile + 0*6+3, APLAN);
			Gen_ShowUnique(  i+0, 4, tile + 0*6+4, APLAN);
			Gen_ShowUnique(  i+1, 4, tile + 0*6+5, APLAN);


			tile += 0x8000;

			/* S */
			i = 7;
			Gen_ShowUnique(  i+0, 4, tile + 3*6, BPLAN);
			Gen_ShowUnique(  i+1, 4, tile + 3*6+1, BPLAN);
			Gen_ShowUnique(  i+0, 5, tile + 3*6+2, BPLAN);
			Gen_ShowUnique(  i+1, 5, tile + 3*6+3, BPLAN);
			Gen_ShowUnique(  i+0, 6, tile + 3*6+4, BPLAN);
			Gen_ShowUnique(  i+1, 6, tile + 3*6+5, BPLAN);

			/* K */
			i = 10;
			Gen_ShowUnique(  i+0, 4, tile + 2*6, BPLAN);
			Gen_ShowUnique(  i+1, 4, tile + 2*6+1, BPLAN);
			Gen_ShowUnique(  i+0, 5, tile + 2*6+2, BPLAN);
			Gen_ShowUnique(  i+1, 5, tile + 2*6+3, BPLAN);
			Gen_ShowUnique(  i+0, 6, tile + 2*6+4, BPLAN);
			Gen_ShowUnique(  i+1, 6, tile + 2*6+5, BPLAN);

			/* I */
			i = 13;
			Gen_ShowUnique(  i+0, 4, tile + 5*6, BPLAN);
			Gen_ShowUnique(  i+1, 4, tile + 5*6+1, BPLAN);
			Gen_ShowUnique(  i+0, 5, tile + 5*6+2, BPLAN);
			Gen_ShowUnique(  i+1, 5, tile + 5*6+3, BPLAN);
			Gen_ShowUnique(  i+0, 6, tile + 5*6+4, BPLAN);
			Gen_ShowUnique(  i+1, 6, tile + 5*6+5, BPLAN);

			/* L */
			i = 16;
			Gen_ShowUnique(  i+0, 4, tile + 1*6, BPLAN);
			Gen_ShowUnique(  i+1, 4, tile + 1*6+1, BPLAN);
			Gen_ShowUnique(  i+0, 5, tile + 1*6+2, BPLAN);
			Gen_ShowUnique(  i+1, 5, tile + 1*6+3, BPLAN);
			Gen_ShowUnique(  i+0, 6, tile + 1*6+4, BPLAN);
			Gen_ShowUnique(  i+1, 6, tile + 1*6+5, BPLAN);

			/* L */
			i = 19;
			Gen_ShowUnique(  i+0, 4, tile + 1*6, BPLAN);
			Gen_ShowUnique(  i+1, 4, tile + 1*6+1, BPLAN);
			Gen_ShowUnique(  i+0, 5, tile + 1*6+2, BPLAN);
			Gen_ShowUnique(  i+1, 5, tile + 1*6+3, BPLAN);
			Gen_ShowUnique(  i+0, 6, tile + 1*6+4, BPLAN);
			Gen_ShowUnique(  i+1, 6, tile + 1*6+5, BPLAN);



			tile = 0xA000 - 32 +firstTile;
			// edition
			for(i=0; i<14; i++)
			{
				Gen_ShowUnique(  17+i, 10, tile + edition[i], APLAN);
			}

			//Start
			for(i=0; i<5; i++)
			{
				Gen_ShowUnique(  12+i, 18, tile + start[i], APLAN);
			}

			//Credit
			for(i=0; i<7; i++)
			{
				Gen_ShowUnique(  12+i, 19, tile + credit[i], APLAN);
			}

			data.defVal = 0; // no item selected
			heroSprite = Anim_New( SELECTOR, &selector_anim, 62-32 +firstTile, 128 +11*8, 128 +18*8, PAL1, data);

			Gen_SetPal( PAL0, title_pal);
			Gen_SetPal( PAL1, hero_pal);
			return;
			break;
		
		
		case LEV_GOVER:
			curLevel.width = 32;
			curLevel.height = 32;
			curLevel.pal =  PAL0;
			curLevel.tile_idx = firstTile; 
			curLevel.fieldA = 0; // no field A
			curLevel.fieldB = 0;
			curLevel.script = 0;
			
			unpack(font2, GFX_WRITE_ADDR(firstTile*32), 1007);
	
			tile = 0x8000 - 32 +firstTile; //priority + PAL0
			for(i=0; i<10; i++)
			{
				Gen_ShowUnique(  11+i, 14, tile + gameover[i], APLAN);
			}
			
			tile = 0x8000 +17; //priority + PAL0
			score = heroScore;
			for(i=5; i>=0; i--)
			{
				Gen_ShowUnique(  13+i, 16, tile + (score%10), APLAN);
				score /= 10;
			}			
	
			Gen_SetPal( PAL0, hero_pal);
			return;
			break;
			
		case LEV_CREDITS:
			curLevel.width = 32;
			curLevel.height = 32;
			curLevel.pal =  PAL0;
			curLevel.tile_idx = firstTile; 
			curLevel.fieldA = 0; // no field A
			curLevel.fieldB = 0;
			curLevel.script = 0;
			
			unpack(font2, GFX_WRITE_ADDR(firstTile*32), 1007);
			tile = 0x8000 - 32 +firstTile;
			for(i=0; i<7; i++)
			{
				Gen_ShowUnique(  12+i, 0, tile + credit[i], APLAN);
			}

			for(i=0; i<11; i++)
			{
				Gen_ShowUnique(  0+i, 5, tile + credit1_1[i], APLAN);
			}
			for(i=0; i<6; i++)
			{
				Gen_ShowUnique(  15+i, 6, tile + credit1_2[i], APLAN);
			}

			for(i=0; i<3; i++)
			{
				Gen_ShowUnique(  0+i, 8, tile + credit2_1[i], APLAN);
			}
			for(i=0; i<3; i++)
			{
				Gen_ShowUnique(  15+i, 9, tile + credit2_2[i], APLAN);
			}
			for(i=0; i<11; i++)
			{
				Gen_ShowUnique(  15+i,10, tile + credit2_3[i], APLAN);
			}
	

			for(i=0; i<6; i++)
			{
				Gen_ShowUnique(  0+i, 15, tile + credit3_1[i], APLAN);
			}
			for(i=0; i<5; i++)
			{
				Gen_ShowUnique(  15+i, 16, tile + credit3_2[i], APLAN);
			}
			for(i=0; i<8; i++)
			{
				Gen_ShowUnique(  15+i, 17, tile + credit3_3[i], APLAN);
			}
			for(i=0; i<6; i++)
			{
				Gen_ShowUnique(  15+i, 18, tile + credit3_4[i], APLAN);
			}
			for(i=0; i<4; i++)
			{
				Gen_ShowUnique(  15+i, 19, tile + credit3_5[i], APLAN);
			}
			for(i=0; i<3; i++)
			{
				Gen_ShowUnique(  15+i, 20, tile + credit3_6[i], APLAN);
			}

			Gen_SetPal( PAL0, hero_pal);
			return;
			break;

			
		
		
		case 1: // 1st level
			unpack(font2, GFX_WRITE_ADDR(firstTile*32), 1007);
			hero_idx = firstTile + 66;
			explo_idx = Anim_Load( &hero_anim, hero_idx );
			shot1_idx = Anim_Load( &explo_anim, explo_idx );
			shot2_idx = Anim_Load( &shot_1_anim, shot1_idx );
			shot3_idx = Anim_Load( &shot_2_anim, shot2_idx );
			npc_idx =   Anim_Load( &shot_3_anim, shot3_idx );
			block_idx = Anim_Load( &npc_anim, npc_idx );
			tileIdx =   Anim_Load( &block_anim, block_idx );

			curLevel.width = level1_width;
			curLevel.height = level1_height;
			curLevel.pal =  PAL0;
			curLevel.tile_idx = tileIdx; 
			curLevel.fieldA = 0; // no field A
			curLevel.fieldB = (ushort *) level1_fieldB;
			curLevel.script = (uchar *) level1_script;

			unpack(level1_tiles, GFX_WRITE_ADDR(tileIdx*32), 35);
			Scroll_Init( );
			Gen_SetPal( PAL0, level1_pal);			
			
			break;
	}
	
	Level_ScoreUpdate( );
	
	// common to all levels	
	data.defVal = 3; //speed
	heroSprite = Anim_New( HERO, &hero_anim, hero_idx, 256, 320, PAL1, data);
	Gen_SetPal( PAL1, hero_pal);

	Gen_SetPal( PAL2, shot_pal);

	Gen_SetPal( PAL3, npc_pal);

	FM_Init( );
	Script_Init( );	
	nSpeed = SPEED;
}

/****** LEVEL_UPDATE ****************
 * update the current level
 *************************************/
void Level_Update(  )
{
	switch( curLevel.idx )
	{
		case LEV_INTRO:
			break;
			
		case LEV_CREDITS:			
		case LEV_GOVER:
			if (Joypad1.key&0xF0)
					curLevel.idx = LEV_SOM;
			break;

		case LEV_SOM:
			if (Joypad1.key&JOY_UP)
			{
				Anim[heroSprite].y -=	8;
				if (Anim[heroSprite].y == 128 +17*8)
					Anim[heroSprite].y = 128 +19*8;					
			}
			else if (Joypad1.key&JOY_DOWN)
			{
				Anim[heroSprite].y +=	8;
				if (Anim[heroSprite].y == 128 +20*8)
					Anim[heroSprite].y = 128 +18*8;					
			}
			
			if (Joypad1.key&0xF0)
			{
				curLevel.idx = (Anim[heroSprite].y - 128 -17*8)/8;
				if (curLevel.idx == 2)
					curLevel.idx = LEV_CREDITS;
			}
			break;
		
		default:
			Level_TextUpdate( );
			Level_ScoreUpdate( );
	}
	
	if ( PauseState )		return;
	
	if (nSpeed == 0)
	{
		if ( Scroll_Update( ) )
		{
			Script_Step( );
		}
		nSpeed = SPEED;
	}
	else
		nSpeed--;

}

void Level_Loop( )
{
	switch( curLevel.idx )
	{
		case 1: // 1st level
			curLevel.fieldB = (ushort *) level1_fieldB;
			curLevel.script = (uchar *) level1_script;
			break;
			
		default:
			return;
	}
	
	Script_Loop( );		
}