#include "genesis.h"
#include "level.h"
#include "scroll.h"

#include "debug.h"

static volatile ushort	workLine;
static volatile long 	scrollV;

/****** SCROLL_REDRAW ****************
 * draw another line
 *************************************/
static void Scroll_Redraw( ulong step )
{
		ushort row, tile;

/*
		if ( step >= (curLevel.height-32)) // don't go further
		{
	       		scrollV--;
	       		return;
		}
*/
		step+=56;
		if ( step <= curLevel.height )
			step = ( curLevel.height - step );
		else
			step -= curLevel.height;

		if (workLine)
			workLine--;
		else
			workLine=63;		


		if (curLevel.fieldB)
		{		
			for (row=0;row<curLevel.width;row++)
			{
				tile = curLevel.fieldB[ (step*curLevel.width) + row];
				if (tile)	tile+=curLevel.tile_idx;
				Gen_ShowUnique(row, workLine, tile, BPLAN);
			}
		}
				
		if (curLevel.fieldA)
		{		
			for (row=0;row<curLevel.width;row++)
			{
				tile = curLevel.fieldA[ (step*curLevel.width) + row];
				if (tile)	tile+=curLevel.tile_idx;
				Gen_ShowUnique(row, workLine, tile, APLAN);
			}
		}		
}

/****** SCROLL_INIT ******************
 * init def value and draw first stuff
 *************************************/
void Scroll_Init( )
{
	volatile	ushort line, row,tile;

	scrollV = 0;
	workLine = 40;
	
	/* draw field B */
	if (curLevel.fieldB)
	{
		for (line=0;line<32;line++)
		{
			for (row=0; row<curLevel.width;row++)
			{
				/* on visible field, the last 32 lines Map[H-32]->Map[H-1]*/
				tile = curLevel.fieldB[(curLevel.height-32+line)*curLevel.width + row];
				if (tile)	tile+=curLevel.tile_idx;
				Gen_ShowUnique(row, line, tile, BPLAN);

				/* on invisible field, the last 32 lines Map[H-64]->Map[H-33]*/
				tile = curLevel.fieldB[(curLevel.height-64+line)*curLevel.width + row];
				if (tile)	tile+=curLevel.tile_idx;
				Gen_ShowUnique(row, line+32, tile, BPLAN);
			}
		}
	}

	if (curLevel.fieldA)
	{
		for (line=0;line<32;line++)
		{
			for (row=0; row<curLevel.width;row++)
			{
				/* on visible field, the last 32 lines Map[H-32]->Map[H-1]*/
				tile = curLevel.fieldA[(curLevel.height-32+line)*curLevel.width + row];
				if (tile)	tile+=curLevel.tile_idx;
				Gen_ShowUnique(row, line, tile, APLAN);

				/* on invisible field, the last 32 lines Map[H-64]->Map[H-33]*/
				tile = curLevel.fieldA[(curLevel.height-64+line)*curLevel.width + row];
				if (tile)	tile+=curLevel.tile_idx;
				Gen_ShowUnique(row, line+32, tile, APLAN);
			}
		}
	}	
}

/****** SCROLL_UPDATE ****************
 * update field
 *************************************/
BOOL Scroll_Update(  )
{
	if ( curLevel.fieldB == 0)	return TRUE;
	
	scrollv( 0, (short int) -( scrollV%(64*8) ) );

	scrollV++;
	scrollV %= ( curLevel.height*8 );  //curLevel.height%32 must be 0
	if (scrollV == 0)
	{
		//AlertEmu("Loop");
		Level_Loop( );	
	}
	if ( (scrollV%8) == 0 )
	{
		Scroll_Redraw( scrollV/8 );
		return (TRUE);		
	}
	
	return (FALSE);
}