#include "genesis.h"
#include "anim.h"
#include "collide.h"
#include "sprite.h"

#include "debug.h"

/********* TO DO **********
 *
 * - multi sprite
 *
 **************************/

static uchar	sprNum;

/****** SPRITE_ADD ******************
 * add current frame of an AnimSpr
 * to Genesis sprites list
 *************************************/
void Sprite_Add( uchar spriteRef )
{
	ushort posx;
	ushort posy;
	ushort size;
	ushort from; // = 0x0004;
	ushort idxTile;
	struct str_Frame *frame;

	if 	(Anim[ spriteRef ].active == FALSE)	return;

	frame = (struct str_Frame *) Anim[spriteRef].AnimLib->Frames[ Anim[spriteRef].curFrame ];
	idxTile = Anim[spriteRef].idxTile + frame->Sprites[0].Idx*Anim[spriteRef].AnimLib->sprite_width*Anim[spriteRef].AnimLib->sprite_height;

	size = (Anim[spriteRef].AnimLib->sprite_width-1);
	size <<= 2;
	size |= (Anim[spriteRef].AnimLib->sprite_height-1);
	size <<= 8;

//	from = 0x0001;
	from = 0x0000;
	from <<=2;
	from |= Anim[ spriteRef ].palIdx;
	from <<=2;
	from |= Anim[ spriteRef ].flip;
	from <<=11;
	from |= (idxTile&0x07FF);


	posx = Anim[ spriteRef ].x + frame->Sprites[0].X;
	posy = Anim[ spriteRef ].y + frame->Sprites[0].Y;

	Gen_DefineSprite(sprNum++,posx,posy,size,from);
}


/****** SPRITE_INIT ******************
 * reset sprite data
 *************************************/
void Sprite_Init( BOOL bFull )
{
	if (bFull)	Gen_ResetSprites(sprNum);
	sprNum = 0;
}

/****** SPRITE_SHOW ******************
 * show all the sprites
 *************************************/
void Sprite_Show( )
{
	if (sprNum)
		Gen_ShowSprites(0,sprNum);
	else
		Gen_ResetSprites(50); // no sprite, clean the list	FULLY OPTIONAL
}